import React, { useState, useEffect } from "react";
import { useDispatch, useSelector } from "react-redux";
import { useNavigate } from "react-router-dom";
import { login } from "../../actions/userAction";
import './Login.css'

function Login() {
  const [email, setEmail] = useState("");
  const [password, setPassword] = useState("");

  const navigate = useNavigate();

  //call the user Action for login
  const dispatch = useDispatch();
  //reducers
  const userLogin = useSelector((state) => state.userLogin);
  //3`
  const { userInfo } = userLogin;

  useEffect(() => {
    const userInfo = localStorage.getItem("userInfo");
    if (userInfo) {
      navigate("/");
    }
  }, [navigate, userInfo]);

  const submitHandler = async (e) => {
    e.preventDefault();
    dispatch(login(email, password));
  };

  return (
    <div className="login-bg">
      <div
        className="d-flex justify-content-center align-items-center"
        style={{ height: "100vh" }}
      >
        <div className="card login-card">
          <div className="card-body login-card-body">
            <div className="d-flex">
              <div className="logo-container">
                <div>
                  <img
                    src="/Images/Logo-no-background.png"
                    alt="Logo"
                    className="img-fluid"
                    style={{ width: "150px" }}
                  />
                </div>
                <h4
                  className="card-title mt-5"
                  style={{
                    width: "150px",
                    fontFamily: "serif",
                    fontWeight: "bold",
                  }}
                >
                  Login into your account
                </h4>
                <div
                  className="card-text mt-3"
                  style={{ fontSize: "17px", fontFamily: "serif" }}
                >
                  Let us make your life easier!
                </div>
              </div>
              <div className="login-container">
                <form className="login-form" onSubmit={submitHandler}>
                  <div className="mb-1">
                    <label
                      htmlFor="email"
                      className="form-label login-form-label"
                    >
                      Email
                    </label>
                    <input
                      type="email"
                      className="form-control login-form-input"
                      id="email"
                      placeholder="name@example.com"
                      onChange={(e) => setEmail(e.target.value)}
                    />
                  </div>
                  <div className="mb-1">
                    <label
                      htmlFor="password"
                      className="form-label login-form-label"
                    >
                      Password
                    </label>
                    <input
                      type="password"
                      className="form-control login-form-input"
                      id="password"
                      placeholder="Your password"
                      onChange={(e) => setPassword(e.target.value)}
                    />
                  </div>
                  <div className="d-flex mt-4">
                    <div className="mt-1">
                      <p style={{ color: "#3c3c3c" }}>
                        Don't have an account?
                        <a
                          style={{
                            color: "#000000",
                            fontWeight: "400",
                            textDecoration: "none",
                          }}
                          href="/register"
                        >
                          Sign up
                        </a>
                      </p>
                    </div>
                    <div className="col-md-4">
                      <button type="submit" className="btn login-btn">
                        Login
                      </button>
                    </div>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  );
}

export default Login