import React, { useState, useEffect } from 'react'
import { useDispatch, useSelector } from "react-redux";
import { useNavigate, use } from "react-router-dom";
import { register } from "../../actions/userAction";
import '../Login/Login.css'

function Register() {
  const [email, setEmail] = useState("");
  const [firstName, setFirstName] = useState("");
  const [lastName, setLastName] = useState("");
  const [password, setPassword] = useState("");

  const dispatch = useDispatch();

  const userRegister = useSelector((state) => state.userRegister);
  const { userInfo } = userRegister;

  const navigate = useNavigate();

  useEffect(() => {
    if (userInfo) {
      navigate("/register");
    }
  }, [navigate, userInfo]);

  const submitHandler = async (e) => {
    e.preventDefault();
    dispatch(register(firstName, lastName, email, password)).then(() => {
      alert("Successfully registered!");
      window.location.href = "/";
    });
  };

  return (
    <div className="login-bg">
      <div
        className="d-flex justify-content-center align-items-center"
        style={{ height: "100vh" }}
      >
        <div className="card login-card">
          <div className="card-body login-card-body">
            <div className="d-flex">
              <div className="logo-container">
                <div>
                  <img
                    src="/Images/Logo-no-background.png"
                    alt="Logo"
                    className="img-fluid"
                    style={{ width: "150px" }}
                  />
                </div>
                <h4
                  className="card-title mt-5"
                  style={{
                    width: "150px",
                    fontFamily: "serif",
                    fontWeight: "bold",
                  }}
                >
                  Create an account here
                </h4>
                <div
                  className="card-text mt-3"
                  style={{ fontSize: "17px", fontFamily: "serif" }}
                >
                  Let's make it happen together!
                </div>
              </div>
              <div className="register-container">
                <form className="login-form" onSubmit={submitHandler}>
                  <div className="mb-1">
                    <label
                      htmlFor="First Name"
                      className="form-label login-form-label"
                    >
                      First Name
                    </label>
                    <input
                      type="text"
                      className="form-control login-form-input"
                      id="fname"
                      placeholder="Your first name"
                      onChange={(e) => setFirstName(e.target.value)}
                      required
                    />
                  </div>
                  <div className="mb-1">
                    <label
                      htmlFor="lname"
                      className="form-label login-form-label"
                    >
                      Last Name
                    </label>
                    <input
                      type="text"
                      className="form-control login-form-input"
                      id="lname"
                      placeholder="Your last name"
                      onChange={(e) => setLastName(e.target.value)}
                      required
                    />
                  </div>
                  <div className="mb-1">
                    <label
                      htmlFor="email"
                      className="form-label login-form-label"
                    >
                      Email
                    </label>
                    <input
                      type="email"
                      className="form-control login-form-input"
                      id="email"
                      placeholder="name@example.com"
                      onChange={(e) => setEmail(e.target.value)}
                      required
                    />
                  </div>
                  <div className="mb-1">
                    <label
                      htmlFor="password"
                      className="form-label login-form-label"
                    >
                      Password
                    </label>
                    <input
                      type="password"
                      className="form-control login-form-input"
                      id="password"
                      placeholder="Your password"
                      onChange={(e) => setPassword(e.target.value)}
                      required
                    />
                  </div>
                  <div className="mt-4" style={{ textAlign: "center" }}>
                    <button type="submit" className="btn create-account">
                      Create Account
                    </button>
                  </div>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  );
}

export default Register